package statemachine2.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.gef.commands.UnexecutableCommand;

import org.eclipse.gmf.runtime.emf.type.core.commands.CreateRelationshipCommand;

import statemachine2.AbstractState;
import statemachine2.CompositeState;
import statemachine2.Statemachine2Package;
import statemachine2.Transition;

import statemachine2.diagram.providers.Statemachine2ElementTypes;

/**
 * @generated
 */
public class StartStateItemSemanticEditPolicy extends
		Statemachine2BaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return getMSLWrapper(new DestroyElementCommand(req) {

			protected EObject getElementToDestroy() {
				View view = (View) getHost().getModel();
				EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
				if (annotation != null) {
					return view;
				}
				return super.getElementToDestroy();
			}

		});
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (Statemachine2ElementTypes.Transition_3001 == req.getElementType()) {
			return req.getTarget() == null ? getCreateStartOutgoingTransition3001Command(req)
					: getCreateCompleteIncomingTransition3001Command(req);
		}
		return super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getCreateStartOutgoingTransition3001Command(
			CreateRelationshipRequest req) {
		return new Command() {
		};
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingTransition3001Command(
			CreateRelationshipRequest req) {
		if (!(req.getSource() instanceof AbstractState)) {
			return UnexecutableCommand.INSTANCE;
		}
		final CompositeState element = (CompositeState) getRelationshipContainer(
				req.getSource(), Statemachine2Package.eINSTANCE
						.getCompositeState(), req.getElementType());
		if (element == null) {
			return UnexecutableCommand.INSTANCE;
		}
		if (req.getContainmentFeature() == null) {
			req.setContainmentFeature(Statemachine2Package.eINSTANCE
					.getCompositeState_Transitions());
		}
		return getMSLWrapper(new CreateIncomingTransition3001Command(req) {

			/**
			 * @generated
			 */
			protected EObject getElementToEdit() {
				return element;
			}
		});
	}

	/**
	 * @generated
	 */
	private static class CreateIncomingTransition3001Command extends
			CreateRelationshipCommand {

		/**
		 * @generated
		 */
		public CreateIncomingTransition3001Command(CreateRelationshipRequest req) {
			super(req);
		}

		/**
		 * @generated
		 */
		protected EClass getEClassToEdit() {
			return Statemachine2Package.eINSTANCE.getCompositeState();
		};

		/**
		 * @generated
		 */
		protected void setElementToEdit(EObject element) {
			throw new UnsupportedOperationException();
		}

		/**
		 * @generated
		 */
		protected EObject doDefaultElementCreation() {
			Transition newElement = (Transition) super
					.doDefaultElementCreation();
			if (newElement != null) {
				newElement.setTo((AbstractState) getTarget());
				newElement.setFrom((AbstractState) getSource());
			}
			return newElement;
		}
	}
}
