package statemachine2.diagram.part;

import java.util.List;
import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.jface.resource.ImageDescriptor;
import java.util.ArrayList;

import org.eclipse.gef.palette.PaletteGroup;

import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

import statemachine2.diagram.providers.Statemachine2ElementTypes;

/**
 * @generated
 */
public class Statemachine2PaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createStates1Group());
		paletteRoot.add(createActions2Group());
		paletteRoot.add(createLinks3Group());
	}

	/**
	 * @generated
	 */
	private PaletteContainer createStates1Group() {
		PaletteContainer paletteContainer = new PaletteGroup("States");
		paletteContainer.add(createState1CreationTool());
		paletteContainer.add(createStartState2CreationTool());
		paletteContainer.add(createStopState3CreationTool());
		paletteContainer.add(createCompositeState4CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private PaletteContainer createActions2Group() {
		PaletteContainer paletteContainer = new PaletteGroup("Actions");
		paletteContainer.add(createAction1CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private PaletteContainer createLinks3Group() {
		PaletteContainer paletteContainer = new PaletteGroup("Links");
		paletteContainer.add(createTransition1CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createState1CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = Statemachine2DiagramEditorPlugin
				.findImageDescriptor("platform:plugin/oaw4.demo.gmf.statemachine2.etc/icons/state.gif");

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(Statemachine2ElementTypes.State_1001);
		elementTypes.add(Statemachine2ElementTypes.State_2002);
		ToolEntry result = new NodeToolEntry("State", "null", smallImage,
				largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStartState2CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = Statemachine2DiagramEditorPlugin
				.findImageDescriptor("platform:plugin/oaw4.demo.gmf.statemachine2.etc/icons/start.gif");

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(Statemachine2ElementTypes.StartState_1002);
		elementTypes.add(Statemachine2ElementTypes.StartState_2003);
		ToolEntry result = new NodeToolEntry("Start State", "null", smallImage,
				largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStopState3CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = Statemachine2DiagramEditorPlugin
				.findImageDescriptor("platform:plugin/oaw4.demo.gmf.statemachine2.etc/icons/stop.gif");

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(Statemachine2ElementTypes.StopState_1003);
		elementTypes.add(Statemachine2ElementTypes.StopState_2004);
		ToolEntry result = new NodeToolEntry("Stop State", "null", smallImage,
				largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCompositeState4CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = Statemachine2DiagramEditorPlugin
				.findImageDescriptor("platform:plugin/oaw4.demo.gmf.statemachine2.etc/icons/compstate.gif");

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(Statemachine2ElementTypes.CompositeState_1004);
		elementTypes.add(Statemachine2ElementTypes.CompositeState_2005);
		ToolEntry result = new NodeToolEntry("Composite State", "null",
				smallImage, largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAction1CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = Statemachine2DiagramEditorPlugin
				.findImageDescriptor("platform:plugin/oaw4.demo.gmf.statemachine2.etc/icons/action.gif");

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(Statemachine2ElementTypes.Action_2001);
		elementTypes.add(Statemachine2ElementTypes.Action_2006);
		ToolEntry result = new NodeToolEntry("Action", "null", smallImage,
				largeImage, elementTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private ToolEntry createTransition1CreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = Statemachine2DiagramEditorPlugin
				.findImageDescriptor("platform:plugin/oaw4.demo.gmf.statemachine2.etc/icons/transition.gif");

		largeImage = smallImage;

		final List relationshipTypes = new ArrayList();
		relationshipTypes.add(Statemachine2ElementTypes.Transition_3001);
		ToolEntry result = new LinkToolEntry("Transition", "null", smallImage,
				largeImage, relationshipTypes);

		return result;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				ImageDescriptor smallIcon, ImageDescriptor largeIcon,
				List elementTypes) {
			super(title, description, smallIcon, largeIcon);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				ImageDescriptor smallIcon, ImageDescriptor largeIcon,
				List relationshipTypes) {
			super(title, description, smallIcon, largeIcon);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
