package statemachine2.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import statemachine2.diagram.edit.parts.CompositeState2EditPart;
import statemachine2.diagram.edit.parts.CompositeStateEditPart;
import statemachine2.diagram.edit.parts.CompositeState_SubStateCompartment2EditPart;
import statemachine2.diagram.edit.parts.CompositeState_SubStateCompartmentEditPart;
import statemachine2.diagram.edit.parts.State2EditPart;
import statemachine2.diagram.edit.parts.StateEditPart;
import statemachine2.diagram.edit.parts.StateMachineEditPart;

import statemachine2.diagram.part.Statemachine2DiagramEditorPlugin;

/**
 * @generated
 */
public class Statemachine2ModelingAssistantProvider extends
		ModelingAssistantProvider {

	/**
	 * @generated
	 */
	public List getTypesForPopupBar(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof StateEditPart) {
			List types = new ArrayList();
			types.add(Statemachine2ElementTypes.Action_2001);
			return types;
		}
		if (editPart instanceof CompositeStateEditPart) {
			List types = new ArrayList();
			types.add(Statemachine2ElementTypes.Action_2006);
			return types;
		}
		if (editPart instanceof State2EditPart) {
			List types = new ArrayList();
			types.add(Statemachine2ElementTypes.Action_2001);
			return types;
		}
		if (editPart instanceof CompositeState2EditPart) {
			List types = new ArrayList();
			types.add(Statemachine2ElementTypes.Action_2006);
			return types;
		}
		if (editPart instanceof CompositeState_SubStateCompartmentEditPart) {
			List types = new ArrayList();
			types.add(Statemachine2ElementTypes.State_2002);
			types.add(Statemachine2ElementTypes.StartState_2003);
			types.add(Statemachine2ElementTypes.StopState_2004);
			types.add(Statemachine2ElementTypes.CompositeState_2005);
			return types;
		}
		if (editPart instanceof CompositeState_SubStateCompartment2EditPart) {
			List types = new ArrayList();
			types.add(Statemachine2ElementTypes.State_2002);
			types.add(Statemachine2ElementTypes.StartState_2003);
			types.add(Statemachine2ElementTypes.StopState_2004);
			types.add(Statemachine2ElementTypes.CompositeState_2005);
			return types;
		}
		if (editPart instanceof StateMachineEditPart) {
			List types = new ArrayList();
			types.add(Statemachine2ElementTypes.State_1001);
			types.add(Statemachine2ElementTypes.StartState_1002);
			types.add(Statemachine2ElementTypes.StopState_1003);
			types.add(Statemachine2ElementTypes.CompositeState_1004);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSource(IAdaptable source) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source,
			IAdaptable target) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForSource(IAdaptable target,
			IElementType relationshipType) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForTarget(IAdaptable source,
			IElementType relationshipType) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target,
			IElementType relationshipType) {
		return selectExistingElement(target, getTypesForSource(target,
				relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source,
			IElementType relationshipType) {
		return selectExistingElement(source, getTypesForTarget(source,
				relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types) {
		if (types.isEmpty()) {
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart == null) {
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		Collection elements = new HashSet();
		for (Iterator it = diagram.getElement().eAllContents(); it.hasNext();) {
			EObject element = (EObject) it.next();
			if (isApplicableElement(element, types)) {
				elements.add(element);
			}
		}
		if (elements.isEmpty()) {
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements
				.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types) {
		IElementType type = ElementTypeRegistry.getInstance().getElementType(
				element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements) {
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(
				Statemachine2DiagramEditorPlugin.getInstance()
						.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(
				shell, labelProvider);
		dialog.setMessage("Available domain model elements:");
		dialog.setTitle("Select domain model element");
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK) {
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
